// sync_reader - A simple buffered input source.

#include "sync_reader.h"

#include <stdexcept>

void SyncReader::getInt(std::function<void(int)> cb)
{
    // need to get more data from readSomeInts
    if (m_buffer.empty())
    {
        if (doReadSome() == 0)
            throw std::runtime_error{"getInt requested but nothing was available"};
    }

    cb(m_buffer.front());
    m_buffer.pop();
    return;
}

size_t SyncReader::doReadSome()
{
    auto to_read = c_max_buffer_size - m_buffer.size();
    int more_ints[to_read];
    auto num_read = readSomeInts(more_ints, to_read);

    for (auto i = 0; i < num_read; i++)
    {
        m_buffer.push(more_ints[i]);
    }

    return num_read;
}
